#include <string>
#include <angelscript.h>
#include <windows.h>

#include "aboutdlg.h"
#include "resource.h"

LRESULT WINAPI UrlProc(HWND wnd, UINT msg, WPARAM wParam, LPARAM lParam);
WNDPROC OrigProc = 0;

CAboutDlg::CAboutDlg()
{
}

int CAboutDlg::DoDialog(acCWindow *parent)
{
	return DoModal(MAKEINTRESOURCE(IDD_ABOUT), parent);
}

LRESULT CAboutDlg::MsgProc(UINT msg, WPARAM wParam, LPARAM lParam)
{
	switch( msg )
	{
	case WM_INITDIALOG:
		SetDlgItemText(hWnd, IDC_ANGELSCRIPT_VERSION, ANGELSCRIPT_VERSION_STRING);
		OrigProc = (WNDPROC)SetWindowLong(GetDlgItem(hWnd, IDC_URL1), GWL_WNDPROC, (LONG)UrlProc);
		OrigProc = (WNDPROC)SetWindowLong(GetDlgItem(hWnd, IDC_URL2), GWL_WNDPROC, (LONG)UrlProc);
		OrigProc = (WNDPROC)SetWindowLong(GetDlgItem(hWnd, IDC_URL3), GWL_WNDPROC, (LONG)UrlProc);
		OrigProc = (WNDPROC)SetWindowLong(GetDlgItem(hWnd, IDC_URL4), GWL_WNDPROC, (LONG)UrlProc);
		return TRUE;

	case WM_COMMAND:
		switch( LOWORD(wParam) )
		{
		case IDOK:
			EndDialog(hWnd, 0);
			return 0;

		case IDC_URL1:
		case IDC_URL2:
		case IDC_URL3:
		case IDC_URL4:
			GoUrl(LOWORD(wParam));
			return 0;
		}
		return TRUE;

	case WM_CLOSE:
		EndDialog(hWnd, 0);
		return TRUE;
	}

	return DefWndProc(msg, wParam, lParam);
}

void CAboutDlg::GoUrl(UINT id)
{
	char text[256];

	GetDlgItemText(hWnd, id, text, 256);

	std::string url;
	url = "http://";
	url += text;

	ShellExecute(NULL, "open", url.c_str(), NULL, NULL, SW_SHOWNORMAL);
}

void OnPaintUrl(HWND wnd)
{
	char text[256];

	PAINTSTRUCT ps;
	HDC dc = BeginPaint(wnd, &ps);

	HFONT font = (HFONT)SendMessage(wnd, WM_GETFONT, 0, 0);
	HFONT oldFont = (HFONT)SelectObject(dc, font);

	GetWindowText(wnd, text, 256);
	int len = strlen(text);
	RECT rc;
	GetClientRect(wnd, &rc);

	SetBkMode(dc, TRANSPARENT);
	SetTextColor(dc, RGB(0,0,255));
	
	DrawText(dc, text, len, &rc, 0);

	DrawText(dc, text, len, &rc, DT_CALCRECT);

	HPEN pen = CreatePen(PS_SOLID, 1, RGB(0,0,255));
	HPEN oldPen = (HPEN)SelectObject(dc, pen);

	MoveToEx(dc, rc.left, rc.bottom-1, 0);
	LineTo(dc, rc.right, rc.bottom-1);

	SelectObject(dc, oldPen);
	DeleteObject(pen);

	SelectObject(dc, oldFont);

	EndPaint(wnd, &ps);
}

LRESULT WINAPI UrlProc(HWND wnd, UINT msg, WPARAM wParam, LPARAM lParam)
{
	switch(msg)
	{
	case WM_PAINT:
		OnPaintUrl(wnd);		
		return 0;
	}

	if( OrigProc )
		return CallWindowProc(OrigProc, wnd, msg, wParam, lParam);

	return DefWindowProc(wnd, msg, wParam, lParam);
}



