//
// CFile
// 
// A simple wrapper for the C standard FILE functions.
//

#ifndef AC_FILE_H
#define AC_FILE_H

#include <stdio.h>

// Error codes
#define EFILE_FAILED				-1
#define EFILE_INVALID_CALL			-2

typedef unsigned char BYTE;

// Seek origin (defined for fseek)
// SEEK_CUR
// SEEK_END
// SEEK_SET

class CFile
{
public:
	CFile();
	~CFile();

	int Open(const char *fileName, const char *mode);
	int Close();

	int FormatWrite(const char *fmt, ...);
	int Write(const void *data, int size, int count);
	int WriteByte(BYTE byte);
	
	int Read(void *data, int size, int count);
	int ReadUntil(void *data, long maxBytes, BYTE delimiter);
	int SkipUntil(BYTE delimiter);
	int Skip(const BYTE *theseBytes, int numBytes);
	int ReadByte();

	int Seek(long offset, int origin);
	int Tell();

	int GetSize();

	bool IsEOF();

public:
	FILE *file;
};

#endif

