#include "image.h"

#define FAIL(r) {returnCode = (r); goto cleanup;}

CImage::CImage()
{
	pixels = 0;
	width  = 0;
	height = 0;
	isTopDown = true;
}

CImage::CImage(int width, int height)
{
	pixels = new PIXEL[width*height];
	if( pixels )
	{
		this->width = width;
		this->height = height;
	}
	else
	{
		this->width = 0;
		this->height = 0;
	}
}

CImage::~CImage()
{
	if( pixels )
		delete[] pixels;
}

int CImage::CopyToDC(HDC dc, int x, int y, int w, int h)
{
	if( pixels == 0 )
		return 0;

	BITMAPINFO bmi;
	GetBitmapInfoHeader((BITMAPINFOHEADER *)&bmi);

	StretchDIBits(dc, x, y, w, h, 0, 0, width, height, pixels, &bmi, DIB_RGB_COLORS, SRCCOPY);

	return 0;
}

void CImage::GetBitmapInfoHeader(BITMAPINFOHEADER *bmih)
{
	bmih->biSize          = sizeof(BITMAPINFOHEADER);
	bmih->biBitCount      = 32;
	bmih->biWidth         = width;
	bmih->biHeight        = isTopDown ? -height : height; 
	bmih->biCompression   = BI_RGB;
	bmih->biPlanes        = 1;
	bmih->biSizeImage     = 0;
	bmih->biClrImportant  = 0;
	bmih->biClrUsed       = 0;
	bmih->biXPelsPerMeter = 0;
	bmih->biYPelsPerMeter = 0;
}

int CImage::Create(int w, int h)
{
	if( pixels ) delete[] pixels;
	pixels = new PIXEL[w*h];
	width  = w;
	height = h;

	return 0;
}
