//
// CSimpleRandomizer
// 
// This class implements a simple pseudo random number generator with the 
// same properties as the C standard rand() function. By putting it in a 
// class it is possible to use more than one PRNG without having them affect 
// one another.
//

#ifndef RAND_H
#define RAND_H

class CSimpleRandomizer
{
public:
	CSimpleRandomizer();
	void AddRef();
	void Release();

	CSimpleRandomizer &operator=(const CSimpleRandomizer &other);

	void  randomize();
	void  setSeed(unsigned int s);
	unsigned int getSeed();
	float getNumber();

protected:
	~CSimpleRandomizer();
	int randSeed;
	int refCount;
};

class asIScriptEngine;

void RegisterScriptRandomizer(asIScriptEngine *engine);

#endif