#include <stdlib.h>
#include <assert.h>
#include <windows.h>
#include <math.h>

#include "sysfuncs.h"
#include "application.h"
#include "scriptstring.h"
#include "outstream.h"
#include "floatimage.h"
#include "rand.h"
#include "pixel.h"

void throwScriptException(asCScriptString *str)
{
	asIScriptContext *context = asGetActiveContext();

	context->SetException((const char *)str->buffer.c_str());
}

void RegisterSystemFunctions(asIScriptEngine *engine)
{
	RegisterScriptString(engine);
	RegisterScriptRandomizer(engine);
	RegisterScriptPixel(engine);
	RegisterScriptImage(engine);

	int r = 0;

	r = engine->RegisterGlobalFunction("void throw(string&in)", asFUNCTION(throwScriptException), asCALL_CDECL); assert(r >= 0);

	r = engine->RegisterGlobalFunction("float sin(float)", asFUNCTION(sinf), asCALL_CDECL); assert(r >= 0);
	r = engine->RegisterGlobalFunction("float cos(float)", asFUNCTION(cosf), asCALL_CDECL); assert(r >= 0);
	r = engine->RegisterGlobalFunction("float sqrt(float)", asFUNCTION(sqrtf), asCALL_CDECL); assert(r >= 0);
	r = engine->RegisterGlobalFunction("float asin(float)", asFUNCTION(asinf), asCALL_CDECL); assert(r >= 0);
	r = engine->RegisterGlobalFunction("float acos(float)", asFUNCTION(acosf), asCALL_CDECL); assert(r >= 0);
	r = engine->RegisterGlobalFunction("float tan(float)", asFUNCTION(tanf), asCALL_CDECL); assert(r >= 0);
	r = engine->RegisterGlobalFunction("float atan(float)", asFUNCTION(atanf), asCALL_CDECL); assert(r >= 0);
}

